/*
 * spi.h
 *
 *  Created on: Sep 18, 2010
 *      Author: Thomas Schmid
 */

#ifndef SPI_H_
#define SPI_H_

#include "core_spi.h"
#include "corespi_regs.h"
#include "../../hal/hal.h"

SPI_slave_t slave;
SPI_instance_t spi;

#define SPI_SLAVE_NONE 0
#define  FABRIC_BASE_ADDR 0x40050000
#define DATA_REG_OFFSET	0x00
#define STATUS_REG_OFFSET 0x08

__attribute__ ((interrupt)) void Fabric_IRQHandler( void )
{
    NVIC_ClearPendingIRQ( Fabric_IRQn );
}

void spi_init()
{
	SPI_init(&spi, 0x40050000, SPI_MODE_MASTER, SPI_MODE0, PCLK_DIV_256);
	slave = SPI_SLAVE_0;

	SPI_slave_select(&spi, SPI_SLAVE_NONE );
	SPI_enable(&spi);
	SPI_set_int(&spi, 1);
//    NVIC_EnableIRQ(Fabric_IRQn);
	NVIC_DisableIRQ(Fabric_IRQn);
	MSS_GPIO_config( MSS_GPIO_15, MSS_GPIO_OUTPUT_MODE);// CSN

}

uint8_t CSN_get()
{
	return (HAL_get_8bit_reg((&spi)->base_addr, SLAVE_SEL) != slave);
}

void CSN_set()
{
	MSS_GPIO_set_output(MSS_GPIO_15, 1);
	//SPI_slave_select(&spi, SPI_SLAVE_NONE );
}
void CSN_clr()
{
	MSS_GPIO_set_output(MSS_GPIO_15, 0);
	SPI_slave_select(&spi, slave );
}


uint8_t SpiByte_write(uint8_t byte)
{
	SPI_transfer(&spi, &byte, &byte, 1);
	return byte;
}

#endif /* SPI_H_ */
